/*

    this source file is a part of 
    lp_parse - a preprocessor for MILP models
    Copyright (C) 1996  Ari Jolma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    for more information please contact 
    Ari Jolma
    Helsinki University of Technology
    Laboratory of Water Resources Engineering
    Building W
    02150 Espoo, Finland
    E-mail: Ari.Jolma@hut.fi

 */

struct index {
  char *name;
  int has_value;
  int value;
  int has_bounds; /* indicates that bounds are as expressions */
  int min;
  int max;
  char *smin;
  char *smax;
  void *next;
};

#define INDEX struct index

/* the new index is the new root, this is because it is easier to loop
   indexlist that is arranged in this way */
void AddINDEX(INDEX **root, INDEX *I);

void RemoveFromINDEXList(INDEX **root, int n);

INDEX *NewINDEX(void);

void DeleteINDEXList(INDEX **root);

INDEX *SearchINDEX(INDEX *root, char *name);

int INDEXListToMin(INDEX *root, int n);

int LoopINDEXList(INDEX *root, int n);

void PrintIndexes(INDEX *root);

/*---------------------------------------------------------------------------*/

struct constant {
  void *next;
  char *name;
  int has_value;
  double value;	
};

#define CONSTANT struct constant

CONSTANT *NewCONSTANT(void);

void AddCONSTANT(CONSTANT **root, CONSTANT *C); 

CONSTANT *SearchCONSTANT(CONSTANT *root, char *name); 

void PrintConstant(CONSTANT *root);

void HashCONSTANT_list(CONSTANT **root);

void print_hash(CONSTANT *root);
